/*
 * defs.h
 *
 * Created: 2012-08-07 07:38:24
 *  Author: dsosnowski
 */ 


#ifndef DEFS_H_
#define DEFS_H_


//-----------------------------
#define DISP_PORT	PORTA
#define DISP_DDR	DDRA 
#define DISP_A		0		
#define DISP_B		1
#define DISP_C		2
#define DISP_D		3
#define DISP_E		4
#define DISP_F		5
#define DISP_G		6
#define DISP_DP		7

#define ANODES_PORT PORTC
#define ANODES_DDR	DDRC
#define ANODE_1 	5
#define ANODE_2 	4
#define ANODE_3 	3
#define ANODE_4 	2
#define ANODE_5 	1
#define ANODE_6 	0
#define _1W_PORT	PORTC
#define _1W_DDR		DDRC
#define _1W_IN		PINC
#define _1W_PIN		6

#define SWITCH_PORT PINB
#define SWITCH_DDR	DDRB
#define	SW1			0
#define	SW2			1
#define	SW3			2
#define	SW4			3
#define	SW5			4
#define	SW6			5

#define EXT_PORT	PORTD
#define EXT_PIN		PORTD
#define EXT_DDR		DDRD
#define FOTO1		2
#define FOTO2		3
#define ALARM		4

#define ALARM_SET	EXT_PORT |= (1<<ALARM)
#define ALARM_CLR	EXT_PORT &= ~(1<<ALARM)


//----------------------------------
#define F_CPU				10000000
#define MCK 				10000000
#define CLEAR				0
#define STOP				0
#define DISABLE				0
#define ZERO				0
#define OFF					0
#define SET					1
#define ENABLE				1
#define MAX					0xFF

//#define MSEC_ON_100HOUR		(36000000-1)
//#define MSEC_ON_100HOUR		(35640000)
#define MSEC_ON_99HOUR		35999900
#define MSEC_ON_DAY			8640000
#define MSEC_ON_HOUR		360000
#define MSEC_ON_10HOUR		3600000
#define MSEC_ON_MIN			6000
#define MSEC_ON_10MIN		60000
#define MSEC_ON_SEC			100
#define MSEC_ON_10SEC		1000

#define FUNC_CLOCK			0
#define FUNC_STOPWATCH		1
#define FUNC_MULTIWATCH		2
#define FUNC_POINTER		3
#define FUNC_POINTER2		4
#define FUNC_CDOWN			5
#define SWITCH_FUNCTION		128

//---mains---
#define MAIN_DELAY			20
#define DISP_REFRESH_FREQ	62	
#define SLIDE_SPEED			100
#define SW_HOLD_TIME		40
#define SW_HOLD_BACK		0

#define PRESSED1			1					
#define PRESSED2			2					
#define PRESSED3			4					
#define PRESSED4			8					
#define PRESSED5			16					
#define PRESSED6			32
#define HOLDING				128
#define HOLDING1			(1+HOLDING)					
#define HOLDING2			(2+HOLDING)					
#define HOLDING3			(4+HOLDING)					
#define HOLDING4			(8+HOLDING)					
#define HOLDING5			(16+HOLDING)					
#define HOLDING6			(32+HOLDING)

//---int part-----------------------------------
#define MASTER_CHANGE		2
#define MASTER_CATCH		1
#define COUNTER_STOP		0
#define COUNTER_RUN			1
//#define COUNTER_BACK		2
#define COUNTER_WFR			3		//wait to run
#define COUNTER_CATCH		1


//---clock part---------------------------------
#define TEMP_INTERVAL_PROC		240
#define TEMP_INTERVAL			320
#define TEMP_SHORTLY_INTERVAL	360
#define DISP_INTERVAL			400

#define ALARM_PERIOD			50

//---score part---------------------------------
#define MODE_READY			1
#define MODE_STOP			0

//---settings part------------------------------
#define BLINK_INTERVAL		30
#define BLINK_PERIOD		20

//---eeprom-------------------------------------
#define CLOCK_EEADR			4
#define SCORE_EEADR			8
#define DOWN_EEADR			12


#endif /* DEFS_H_ */
