

#include <avr/io.h>
#include <inttypes.h>
#include "ee_mem.h"

//--------------------------------- 
void ee_write(char address, char data)
{
	while(EECR & (1<<EEWE)); 		//Wait for completion of previous write

	EEARH = 0;						//Set up address
	EEARL = address;				//Set down address and data registers
	EEDR = data;

	EECR |= (1<<EEMWE);				//Write logical one to EEMPE
	EECR |= (1<<EEWE);				//Start eeprom write by setting EEPE
}

//--------------------------------- 
char ee_read(char address)
{
	while(EECR & (1<<EEWE));		//Wait for completion of previous write

	EEARH = 0;						//Set up address
	EEARL = address;				//Set up address register
	EECR |= (1<<EERE);				//Start eeprom read by writing EERE

	return EEDR;					//Return data from data register
}

//--------------------------------- 
void ee_32write(char address, char *pt_data)
{
	char i = 4;
	while (i)
	{
		while(EECR & (1<<EEWE)); 		//Wait for completion of previous write

		EEARH = 0;						//Set up address
		EEARL = address;				//Set down address and data registers
		EEDR = *pt_data;

		EECR |= (1<<EEMWE);				//Write logical one to EEMPE
		EECR |= (1<<EEWE);				//Start eeprom write by setting EEPE
	
		pt_data++;
		address++;
		i--;	
	}
}

//--------------------------------- 
void ee_32read(char address, char *pt_data)
{	
	char i = 4;
	while (i)
	{
		while(EECR & (1<<EEWE));		//Wait for completion of previous write

		EEARH = 0;						//Set up address
		EEARL = address;				//Set up address register
		EECR |= (1<<EERE);				//Start eeprom read by writing EERE
		*pt_data = EEDR;
		
		pt_data++;
		address++;
		i--;	
	}
}
